Attribute VB_Name = "modMain"
Public strLogFile As String
Public dunConnection As String
Public recordLog As Boolean
Public blnPrimaryServerRunning As Boolean
Public blnIsBackup As Boolean
Public strPrimaryServer As String
Public strBackupServer As String
Public blnLANConnected As Boolean
Public strRelayServer As String
Public blnModemConnected As Boolean
Public lngRelayTimeout As Long

Public Enum eConnection
    cNotConnected = 0
    cConnectionLAN = 5
    cConnectionDialup = 6
End Enum

Public Enum eRelayConnection
    rcNotConnected = 4
    rcConnected = 3
End Enum

Public Enum eServerResponse
    srNotInUse = -1
    srNoResponse = 0
    srUnknownResponse = 1
    srErrorOccured = 2
    srRelayConnected = 3
    srRelayDisconnected = 4
    srConnectionLAN = 5
    srConnectionDialup = 6
    srConnectionNone = 7
    srServerRunning = 8
    srServerNotRunning = 9
End Enum

Public Enum eServerQuery
    sqNoQuery = 0
    sqRelayConnection = 1
    sqServerConnection = 2
    sqBackupShutdown = 3
End Enum

Public Function addToLog(strMessage As String)
    If recordLog = False Then Exit Function
    On Error Resume Next
    Dim lngFreeFile As Long
    lngFreeFile = FreeFile()
    Open strLogFile For Append As #lngFreeFile
        Print #lngFreeFile, "[" & Format(Now(), "mm/dd/yyyy hh:mm:ss") & "] " & strMessage
    Close #lngFreeFile
End Function

Public Function TrimSlash(strTrim As String) As String
    If Mid(strTrim, Len(strTrim) - 1, 1) = "\" Then
        TrimSlash = Mid(strTrim, 1, Len(strTrim) - 1)
    Else
        TrimSlash = strTrim
    End If
End Function

Public Function FileExists(strCheckPath As String) As Boolean
    On Error GoTo handleError
    If FileLen(strCheckPath) > 0 Then
        FileExists = True
    Else
        FileExists = False
    End If
    Exit Function
    
handleError:
    FileExists = False
    Exit Function
End Function

Public Function dunConnectionExists(strConnectionName As String) As Boolean
    Dim dunConnections() As String
    DUN_Services dunConnections()
    For Each duConnection In dunConnections()
        If duConnection = strConnectionName Then dunConnectionExists = True
    Next
End Function

Public Function getUBound(ByRef arrArray As Variant) As Long
    On Error GoTo handleError
    getUBound = UBound(arrArray)
    Exit Function
    
handleError:
    getUBound = -1
    Exit Function
End Function
